package com.jkcredit.controller;

import com.jkcredit.config.BaseResult;
import com.jkcredit.service.CarService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.io.UnsupportedEncodingException;
import java.util.Map;

/**
 * @description:
 * @author: sunzhaoning
 * @create: 2019-05-14 11:08
 * @version: V1.0
 **/
@Slf4j
@RestController
@RequestMapping("/api")
public class CarInfoController {

    @Autowired
    private CarService carService;

    @PostMapping("/v1")
    public BaseResult<String> doPost(@RequestBody Map<String, String> params) throws UnsupportedEncodingException {
        return carService.car(params);
    }

}
